package com.ejie.ab79.control.expedientes;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import com.ejie.ab79.clientesWS.ab61WebService.Usuario;
import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.expedientes.CanalesAviso;
import com.ejie.ab79.model.expedientes.DatosTerceros;
import com.ejie.ab79.model.expedientes.RelExpTer;
import com.ejie.ab79.model.expedientes.Sexo;
import com.ejie.ab79.service.RelEstInsService;
import com.ejie.ab79.service.expedientes.CanalesAvisoService;
import com.ejie.ab79.service.expedientes.DatosDireccionesService;
import com.ejie.ab79.service.expedientes.DatosTercerosService;
import com.ejie.ab79.service.expedientes.RelExpTerService;
import com.ejie.ab79.service.expedientes.SexoService;

/**
 * DatosTercerosController  
 * 
 *  
 */

@Controller
@RequestMapping(value = "/datosterceros")

public class DatosTercerosController {

	private static final Logger logger = LoggerFactory.getLogger(DatosTercerosController.class);

	@Autowired
	private DatosTercerosService datosTercerosService;

	@Autowired
	private RelEstInsService relEstInsService;

	@Autowired
	private DatosDireccionesService datosDireccionesService;

	@Autowired
	private CanalesAvisoService canalesAvisoService;

	@Autowired
	private SexoService sS;

	@Autowired
	private RelExpTerService relExpTerService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idTercero
	 *            Integer
	 * @return DatosTerceros Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idTercero}", method = RequestMethod.GET)
	public @ResponseBody DatosTerceros get(@PathVariable Integer idTercero) {
		DatosTerceros datosTerceros = new DatosTerceros();
		datosTerceros.setIdTercero(idTercero);
		datosTerceros = this.datosTercerosService.find(datosTerceros);
		DatosTercerosController.logger.info("[GET - findBy_PK] : Obtener DatosTerceros por PK");
		return datosTerceros;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterDatosTerceros
	 *            DatosTerceros Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<DatosTerceros> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<DatosTerceros> getAll(@ModelAttribute DatosTerceros filterDatosTerceros) {
		DatosTercerosController.logger.info("[GET - find_ALL] : Obtener DatosTerceros por filtro");
		return this.datosTercerosService.findAll(filterDatosTerceros, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param datosTerceros
	 *            DatosTerceros Bean que contiene la informacion a modificar.
	 * @return DatosTerceros Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody DatosTerceros edit(@RequestBody DatosTerceros datosTerceros,
			@ModelAttribute("usuario") Usuario usuario) {

		datosTerceros.setUsuarioUltmodificacion(usuario.getUsuario());
		DatosTerceros datosTercerosAux = this.datosTercerosService.update(datosTerceros);
		DatosTercerosController.logger.info("[PUT] : DatosTerceros actualizado correctamente");
		return datosTercerosAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param datosTerceros
	 *            DatosTerceros Bean que contiene la informacion con la que se
	 *            va a crear el nuevo registro.
	 * @return DatosTerceros Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody DatosTerceros add(@RequestBody DatosTerceros datosTerceros) {
		DatosTerceros datosTercerosAux = this.datosTercerosService.add(datosTerceros);
		DatosTercerosController.logger.info("[POST] : DatosTerceros insertado correctamente");
		return datosTercerosAux;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		DatosTercerosController.logger.info("[GET - View] : datosterceros");
		return "datosterceros";
	}

	@RequestMapping(value = "/buscarTercero/{numeroRegistro}/{idInspeccion}", method = RequestMethod.GET)
	public @ResponseBody DatosTerceros buscarTercero(@PathVariable String numeroRegistro,
			@PathVariable Integer idInspeccion, @ModelAttribute("usuario") Usuario usuario) throws Exception {
		DatosTercerosController.logger.info("[GET] : Buscar Tercero AB63");

		return this.datosTercerosService.buscarTercero(numeroRegistro, idInspeccion, usuario);
	}

	@RequestMapping(value = "/eliminarTitular/{idTercero}", method = RequestMethod.DELETE)
	public @ResponseBody DatosTerceros eliminarTitular(@PathVariable Integer idTercero) {
		DatosTercerosController.logger.info("[DELETE] : Eliminar Titular");
		DatosTerceros datosTercero = new DatosTerceros(idTercero);

		this.relEstInsService.eliminarTercero(datosTercero);

		this.datosDireccionesService.eliminarTercero(datosTercero);

		this.datosTercerosService.removeIdTercero(datosTercero);

		return datosTercero;
	}

	/**
	 * Borrar tercero tipo personaContacto o representanteLegal
	 * 
	 * @param datosTercero
	 * @return DatosTercero
	 */
	@RequestMapping(value = "/delete/{idTercero}", method = RequestMethod.DELETE)
	public @ResponseBody() DatosTerceros removePersona(@PathVariable int idTercero) {

		DatosTerceros datosTerceros = new DatosTerceros();
		datosTerceros.setIdTercero(idTercero);

		RelExpTer relExpTer = new RelExpTer();
		relExpTer.setDatosTerceros(datosTerceros);

		List<RelExpTer> listaRelExpTer = relExpTerService.findAll(relExpTer, null);

		for (int i = 0; i < listaRelExpTer.size(); i++) {
			relExpTerService.remove(listaRelExpTer.get(i));
		}

		datosTercerosService.removeIdTercero(datosTerceros);
		return datosTerceros;
	}

	/**
	 * Metodo que nos carga el formulario de un tercero * @param idTercero
	 * Integer
	 * 
	 * @return Terceros Objeto correspondiente al identificador indicado.
	 * 
	 */
	@RequestMapping(value = "/{idExpediente}/{idTercero}/{folderId}/{tipo}/{partipantId}", method = RequestMethod.GET)
	public String getByid(@PathVariable int idExpediente, @PathVariable int idTercero, @PathVariable String folderId,
			@PathVariable String tipo, Model model, @PathVariable String partipantId) {
		long tipoPersona = 0L;
		String idioma = LocaleContextHolder.getLocale().getLanguage();
		DatosTerceros datosTercero = new DatosTerceros();
		if (partipantId.equals(Constantes.PARTICIPACIONID_NULA)) {
			if (tipo.equals(Constantes.PERSONA_CONTACTOS)) {
				tipoPersona = Constantes.TiposTercero.PERSONA_CONTACTO;
			} else if (tipo.equals(Constantes.DENUNCIADO)) {
				tipoPersona = Constantes.TiposTercero.DENUNCIADO;
			} else {
				tipoPersona = Constantes.TiposTercero.REPRESENTANTE_LEGAL;
			}
			datosTercero = this.datosTercerosService.findPersonacontactoResponsableLegal(idTercero, tipoPersona,
					idExpediente);
		} else {
			datosTercero = this.datosTercerosService.findTercero(idTercero, partipantId);
		}

		if (datosTercero != null) {

			List<CanalesAviso> canalesAvisoList = this.canalesAvisoService.findCanalesTercero(idTercero);
			datosTercero.setCanalesAvisos(canalesAvisoList);
		}

		if (datosTercero == null) {
			model.addAttribute("datosTerceros", new DatosTerceros());
		} else {
			model.addAttribute("datosTerceros", datosTercero);
		}

		String hayTipoSMS = "N";
		String hayTipoEMAIL = "N";

		if (null != datosTercero && datosTercero.getCanalesAvisos() != null
				&& datosTercero.getCanalesAvisos().size() > 0) {
			for (int i = 0; i < datosTercero.getCanalesAvisos().size(); i++) {
				if (datosTercero.getCanalesAvisos().get(i).getTiposCanalAviso() != null
						&& datosTercero.getCanalesAvisos().get(i).getTiposCanalAviso().getIdTipoCanalAviso()
								.equals(Constantes.TIPO_CANAL_AVISO_SMS)) {
					hayTipoSMS = "S";
				}
				if (datosTercero.getCanalesAvisos().get(i).getTiposCanalAviso() != null
						&& datosTercero.getCanalesAvisos().get(i).getTiposCanalAviso().getIdTipoCanalAviso()
								.equals(Constantes.TIPO_CANAL_AVISO_EMAIL)) {
					hayTipoEMAIL = "S";
				}
			}
		}

		model.addAttribute("hayTipoSMS", hayTipoSMS);
		model.addAttribute("hayTipoEMAIL", hayTipoEMAIL);

		model.addAttribute("lenguaje", idioma);

		return "datosSolicitantes";
	}

	/**
	 * Metod para hacer un update
	 * 
	 * @param tercero
	 * @return Terceros Bean resultante del proceso de creacion
	 */
	@RequestMapping(value = "/save", method = RequestMethod.POST)
	public @ResponseBody DatosTerceros savePersona(@RequestBody DatosTerceros datosTercero) {
		this.datosTercerosService.update(datosTercero);
		return datosTercero;
	}

	@RequestMapping(value = "/{idTercero}/{tipo}/{idExpediente}/remove")
	public String removeByidRemove(@PathVariable int idTercero, @PathVariable String tipo,
			@PathVariable int idExpediente, Model model) throws Exception {

		long tipoPersona = 0L;
		String idioma = LocaleContextHolder.getLocale().getLanguage();
		DatosTerceros datosTercero = new DatosTerceros();
		if (tipo.equals(Constantes.PERSONA_CONTACTO)) {
			tipoPersona = Constantes.TiposTercero.PERSONA_CONTACTO;
		} else {
			tipoPersona = Constantes.TiposTercero.REPRESENTANTE_LEGAL;
		}
		datosTercero = this.datosTercerosService.findPersonacontactoResponsableLegal(idTercero, tipoPersona,
				idExpediente);
		List<Sexo> sexo = this.sS.findAll();
		if (datosTercero == null) {
			model.addAttribute("datosTerceros", new DatosTerceros());
		} else {
			model.addAttribute("datosTerceros", datosTercero);
		}
		model.addAttribute("sexoidiomas", sexo);
		model.addAttribute("lenguaje", idioma);

		String hayTipoSMS = "N";
		String hayTipoEMAIL = "N";
		model.addAttribute("hayTipoSMS", hayTipoSMS);
		model.addAttribute("hayTipoEMAIL", hayTipoEMAIL);
		model.addAttribute("eliminar", 1);
		model.addAttribute("idExpediente", idExpediente);
		return "datosSolicitantes";
	}

}
